OBJ

  Pst : "Parallax Serial Terminal"
  F : "F32"
    
CON

  _CLKMODE = XTAL1 + PLL16X 
  _XINFREQ = 5_000_000

VAR

  long x
  long y
  long z
  long pseudoHeading, pseudoTiltX, pseudoTiltY
          
PUB Main

  F.Start
  waitcnt(clkfreq/1000 + cnt)     ' Power up delay
  pst.start(115200)

  repeat
 
    getRaw                           ' Gather raw data from compass       
    pst.Char(1)
    ShowVals

PUB GetRaw | fX, fY, fZ 
  ' Get raw data from continous output

  x := 30 ' x, y & z could be read from sensor
  z := 40 
  y := 50 

  fX := F.FFloat(x)
  fY := F.FFloat(y)
  fZ := F.FFloat(z)
 
  pseudoHeading := F.FRound(F.FMul(F.Degrees(F.ATan2(fY, fX)), 1000.0))
  pseudoTiltX := F.FRound(F.FMul(F.Degrees(F.ATan2(fZ, fX)), 1000.0))
  pseudoTiltY := F.FRound(F.FMul(F.Degrees(F.ATan2(fZ, fY)), 1000.0))
  
PUB ShowVals
  ' Display XYZ compass values and heading
        
  Pst.Position(0, 0)
  Pst.str(string("X = "))        
  Pst.dec(x)
  Pst.str(string("   "))
  Pst.PositionX(8) 
  Pst.str(string(", Y = "))
  Pst.dec(y)
  Pst.str(string("   "))
  Pst.PositionX(18) 
  pst.str(string(", Z ="))
  pst.dec(z)
  pst.ClearEnd
  Pst.Position(0, 2)
  pst.str(string("Course = "))
  DecPoint(pseudoHeading, 1000)       
  'pst.dec(pseudoHeading)
  pst.str(string("   "))
  Pst.PositionX(17) 
  pst.str(string(", tiltX = "))
  DecPoint(pseudoTiltX, 1000)       
  'pst.dec(pseudoTiltX)
  pst.str(string("   "))
  Pst.PositionX(33) 
  pst.str(string(", tiltY = "))
  DecPoint(pseudoTiltY, 1000)       
  'pst.dec(pseudoTiltY)
  Pst.ClearEnd

PUB DecPoint(value, denominator)

  if value < 0
    Pst.Char("-")
    -value
      
  if value => denominator
    result := value / denominator
    Pst.Dec(result)
    value //= denominator     
  else    
    Pst.Char("0")
  Pst.Char(".")  
  repeat while denominator > 1
    denominator /= 10
    if value => denominator
      result := value / denominator
      Pst.Dec(result)
      value //= denominator
    else
      Pst.Char("0")
  